; CIRCLE__DEFINE.PRO
;
; Definition of the concrete class CIRCLE, a derived class of SHAPE.
;
; Written by R.M. Dimeo (12/01/02)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function circle::getArea
return,!pi*self.radius^2
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function circle::draw
plots,*self.xPtr,*self.yPtr,/device
return,1
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function circle::init,xc = xc,yc = yc, radius = radius
retVal =self -> shape::init()
if retVal ne 1 then return,retVal
if n_elements(xc) eq 0 then xc = 100.0
if n_elements(yc) eq 0 then yc = 100.0
if n_elements(radius) eq 0 then radius = 100.0
self.xc = xc
self.yc = yc
self.radius = radius
nth = 100
th = (2.0*!pi/(nth-1.))*findgen(nth)
*self.xPtr = xc + radius*cos(th)
*self.yPtr = yc + radius*sin(th)
return,1
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro circle__define
define = { circle, inherits SHAPE, $
			radius:0.0, $
			xc:0.0, $
			yc:0.0	}
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;