; NMCURVECHANGE.PRO
;
; Non-modal widget dialog.
;
; Written by R.M. Dimeo (11/25/02)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro nmSendInfo,pInfo
  widget_control,(*pInfo).curveGroup,get_value = index
  if index eq 0 then begin	; SIN
  	(*pInfo).data[*,1] = sin((*pInfo).data[*,0])
  endif else begin			; COS
  	(*pInfo).data[*,1] = cos((*pInfo).data[*,0])
  endelse

  nmInfo = {NMCURVEEVENT,$
                        id:(*pInfo).notifyIDs[0],$
                        top:(*pInfo).notifyIDs[1],$
                        handler:0l,$
                        data:(*pInfo).data}
  if widget_info((*pInfo).notifyIDs[0],/valid_id) then begin $
    widget_control,(*pInfo).notifyIDs[0],send_event = nmInfo
  endif
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro nmccCleanup,tlb
widget_control,tlb,get_uvalue = pInfo
ptr_free,pInfo
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro nmccEvent,event
uname = widget_info(event.id,/uname)
case uname of
'CURVEGROUP':	$
	begin
	widget_control,event.top,get_uvalue = pInfo
	if (*pInfo).notifyIds[0] ne 0L then nmSendInfo,pInfo
	end
'DONE':			$
	begin
	widget_control,event.top,get_uvalue = pInfo
	if (*pInfo).notifyIds[0] ne 0L then nmSendInfo,pInfo
	widget_control,event.top,/destroy
	end
else:
endcase
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro nmCurveChange,x,group_leader = group_leader,notifyIds = notifyIds
; The first thing to check is if there is an instance of this program running
; associated with the calling program.  If so then proceed no further.
if n_elements(notifyIds) eq 0 then notifyIds = [0L,0L]
if n_elements(group_leader) eq 0 then begin
  group_leader = 0L
endif
tlb = widget_base(group_leader = group_leader,/col)
; Create a registered name that is unique for the calling program.  Use the
; group leader's id for instance...
registerName = 'nmcc'+strtrim(string(group_leader),2)
if xregistered(registerName) then return

curveType = ['sin(x)','cos(x)']
curveGroup = cw_bgroup(tlb, curveType, /col, /exclusive,$
         label_top='Curve Type',/no_release,$
         frame=1,set_value=0,/return_index,uname = 'CURVEGROUP')
void = widget_button(tlb,value = 'DISMISS',uname = 'DONE')
widget_control,tlb,/realize
y = fltarr(n_elements(x))
data = [[x],[y]]

info = {	curveGroup:curveGroup,	$
			notifyIds:notifyIds,	$
			data:data	$
		}

pInfo = ptr_new(info,/no_copy)
widget_control,tlb,set_uvalue = pInfo
xmanager,registerName,tlb,event_handler = 'nmccEvent',cleanup = 'nmccCleanup'
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;