; XTWOWIN.PRO
;
; Simple widget application that has two zoomable, resizable windows.
;
; Written by R.M. Dimeo (11/27/02)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro xtwCleanup,tlb
widget_control,tlb,get_uvalue = pState
wdelete,(*pState).win1State.winPix
wdelete,(*pState).win2State.winPix
ptr_free,(*pState).win1State.xPtr,(*pState).win2State.xPtr
ptr_free,(*pState).win1State.yPtr,(*pState).win2State.yPtr
ptr_free,(*pState).dataPtr1, (*pState).dataPtr2
ptr_free,pState
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro xtwQuit,event
widget_control,event.top,/destroy
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro xtwPlot1,event
widget_control,event.top,get_uvalue = pState
data = *(*pState).dataPtr1
x = data[*,0] & y = data[*,1]
if (*pState).win1State.autoscale eq 1 then begin
  (*pState).win1State.xrange = [min(x),max(x)]
  dy = 0.1*(max(y)-min(y))
  (*pState).win1State.yrange = [min(y)-dy,max(y)+dy]
endif
plot,x,y,xrange = (*pState).win1State.xrange,xstyle = 1, $
  yrange = (*pState).win1State.yrange,ystyle = 1
*(*pState).win1State.xPtr = !x
*(*pState).win1State.yPtr = !y
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro xtwPlot2,event
widget_control,event.top,get_uvalue = pState
data = *(*pState).dataPtr2
x = data[*,0] & y = data[*,1]
if (*pState).win2State.autoscale eq 1 then begin
  (*pState).win2State.xrange = [min(x),max(x)]
  dy = 0.1*(max(y)-min(y))
  (*pState).win2State.yrange = [min(y)-dy,max(y)+dy]
endif
plot,x,y,xrange = (*pState).win2State.xrange,xstyle = 1, $
  yrange = (*pState).win2State.yrange,ystyle = 1
*(*pState).win2State.xPtr = !x
*(*pState).win2State.yPtr = !y
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro refresh1,event
widget_control,event.top,get_uvalue = pState
wset,(*pState).win1State.winPix
xtwPlot1,event
wset,(*pState).win1State.winVis
device,copy = [0,0,!d.x_size,!d.y_size,0,0,(*pState).win1State.winPix]
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro refresh2,event
widget_control,event.top,get_uvalue = pState
wset,(*pState).win2State.winPix
xtwPlot2,event
wset,(*pState).win2State.winVis
device,copy = [0,0,!d.x_size,!d.y_size,0,0,(*pState).win2State.winPix]
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro xtwWin1Draw,event
widget_control,event.top,get_uvalue = pState
case event.type of
0:	begin		; button press
	  (*pState).win1State.mouse = event.press
	  if (*pState).win1State.mouse eq 4 then begin
	   (*pState).win1State.autoscale = 1

	    !x = *(*pState).win1State.xPtr
	    !y = *(*pState).win1State.yPtr
	    wset,(*pState).win1State.winPix
	    xtwPlot1,event
	    wset,(*pState).win1State.winVis
	    device,copy = [0,0,!d.x_size,!d.y_size,0,0,(*pState).win1State.winPix]
	  endif
	  if (*pState).win1State.mouse eq 1 then begin
	    (*pState).win1State.xPos = event.x
	    (*pState).win1State.yPos = event.y
	    !x = *(*pState).win1State.xPtr
	    !y = *(*pState).win1State.yPtr
	    wset,(*pState).win1State.winVis
	    device,copy = [0,0,!d.x_size,!d.y_size,0,0,(*pState).win1State.winPix]
	    (*pState).win1State.autoscale = 0
	  endif
	end
1:	begin	; button release
	 if (*pState).win1State.mouse eq 1 then begin
	  !x = *(*pState).win1State.xPtr
	  !y = *(*pState).win1State.yPtr
      xll = Min([(*pState).win1State.xpos, event.x], Max=xur)
      yll = Min([(*pState).win1State.ypos, event.y], Max=yur)
	  ll = convert_coord(xll,yll,/device,/to_data)
	  ur = convert_coord(xur,yur,/device,/to_data)
	  (*pState).win1State.xrange = [ll[0],ur[0]]
	  (*pState).win1State.yrange = [ll[1],ur[1]]
	  wset,(*pState).win1State.winPix
	  xtwPlot1,event
	  wset,(*pState).win1State.winVis
	  device,copy = [0,0,!d.x_size,!d.y_size,0,0,(*pState).win1State.winPix]
	  (*pState).win1State.mouse = 0B
	 endif
	 if (*pState).win1State.mouse eq 4 then begin
	  !x = *(*pState).win1State.xPtr
	  !y = *(*pState).win1State.yPtr
	  wset,(*pState).win1State.winPix
	  xtwPlot1,event
	  wset,(*pState).win1State.winVis
	  device,copy = [0,0,!d.x_size,!d.y_size,0,0,(*pState).win1State.winPix]
	  (*pState).win1State.mouse = 0B
	 endif
	end
2:	begin	; mouse motion
	  if (*pState).win1State.mouse eq 1 then begin
	  	xc = [(*pState).win1State.xpos,event.x,event.x,$
	  	      (*pState).win1State.xpos,$
	  	      (*pState).win1State.xpos]
	  	yc = [(*pState).win1State.ypos,(*pState).win1State.ypos,$
	  	      event.y,event.y,$
	  	      (*pState).win1State.ypos]
	  	wset,(*pState).win1State.winVis
	  	device,copy = [0,0,!d.x_size,!d.y_size,0,0,(*pState).win1State.winPix]
	  	plots,xc,yc,/device
	  endif
	end
else:
endcase
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro xtwWin2Draw,event
widget_control,event.top,get_uvalue = pState
case event.type of
0:	begin		; button press
	  (*pState).win2State.mouse = event.press
	  if (*pState).win2State.mouse eq 4 then begin
	   (*pState).win2State.autoscale = 1

	    !x = *(*pState).win2State.xPtr
	    !y = *(*pState).win2State.yPtr
	    wset,(*pState).win2State.winPix
	    xtwPlot2,event
	    wset,(*pState).win2State.winVis
	    device,copy = [0,0,!d.x_size,!d.y_size,0,0,(*pState).win2State.winPix]
	  endif
	  if (*pState).win2State.mouse eq 1 then begin
	    (*pState).win2State.xPos = event.x
	    (*pState).win2State.yPos = event.y
	    !x = *(*pState).win2State.xPtr
	    !y = *(*pState).win2State.yPtr
	    wset,(*pState).win2State.winVis
	    device,copy = [0,0,!d.x_size,!d.y_size,0,0,(*pState).win2State.winPix]
	    (*pState).win2State.autoscale = 0
	  endif
	end
1:	begin	; button release
	 if (*pState).win2State.mouse eq 1 then begin
	  !x = *(*pState).win2State.xPtr
	  !y = *(*pState).win2State.yPtr
      xll = Min([(*pState).win2State.xpos, event.x], Max=xur)
      yll = Min([(*pState).win2State.ypos, event.y], Max=yur)
	  ll = convert_coord(xll,yll,/device,/to_data)
	  ur = convert_coord(xur,yur,/device,/to_data)
	  (*pState).win2State.xrange = [ll[0],ur[0]]
	  (*pState).win2State.yrange = [ll[1],ur[1]]
	  wset,(*pState).win2State.winPix
	  xtwPlot2,event
	  wset,(*pState).win2State.winVis
	  device,copy = [0,0,!d.x_size,!d.y_size,0,0,(*pState).win2State.winPix]
	  (*pState).win2State.mouse = 0B
	 endif
	 if (*pState).win2State.mouse eq 4 then begin
	  !x = *(*pState).win2State.xPtr
	  !y = *(*pState).win2State.yPtr
	  wset,(*pState).win2State.winPix
	  xtwPlot2,event
	  wset,(*pState).win2State.winVis
	  device,copy = [0,0,!d.x_size,!d.y_size,0,0,(*pState).win2State.winPix]
	  (*pState).win2State.mouse = 0B
	 endif
	end
2:	begin	; mouse motion
	  if (*pState).win2State.mouse eq 1 then begin
	  	xc = [(*pState).win2State.xpos,event.x,event.x,$
	  	      (*pState).win2State.xpos,$
	  	      (*pState).win2State.xpos]
	  	yc = [(*pState).win2State.ypos,(*pState).win2State.ypos,$
	  	      event.y,event.y,$
	  	      (*pState).win2State.ypos]
	  	wset,(*pState).win2State.winVis
	  	device,copy = [0,0,!d.x_size,!d.y_size,0,0,(*pState).win2State.winPix]
	  	plots,xc,yc,/device
	  endif
	end
else:
endcase
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro xtwEvent,event
; This event handler will handle the resize events
widget_control,event.top,get_uvalue = pState
geom = widget_info(event.top,/geometry)
widget_control,(*pState).win1State.win,draw_xsize = fix(0.5*event.x), $
  draw_ysize = event.y
widget_control,(*pState).win2State.win,draw_xsize = fix(0.5*event.x), $
  draw_ysize = event.y
wdelete,(*pState).win1State.winPix
window,/free,/pixmap,xsize = fix(0.5*event.x),ysize = event.y
(*pState).win1State.winPix = !d.window
wdelete,(*pState).win2State.winPix
window,/free,/pixmap,xsize = fix(0.5*event.x),ysize = event.y
(*pState).win2State.winPix = !d.window
refresh1,event
refresh2,event
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro xTwoWin
device,decomposed = 0
loadct,0,/silent

tlb = widget_base(/row,title = 'Application with two resizable windows', $
  /tlb_size_events,mbar = bar)
filemenu = widget_button(bar,value = 'FILE',/menu)
void = widget_button(filemenu,value = 'QUIT',event_pro = 'xtwQuit')
xsize = 300 & ysize = 300
win1 = widget_draw(tlb,xsize = xsize,ysize = ysize,/button_events, $
  /motion_events,event_pro = 'xtwWin1Draw')
win2 = widget_draw(tlb,xsize = xsize,ysize = ysize,/button_events, $
  /motion_events,event_pro = 'xtwWin2Draw')
widget_control,tlb,/realize

widget_control,win1,get_value = winVis1
widget_control,win2,get_value = winVis2
window,/free,/pixmap,xsize = xsize,ysize = ysize
winPix1 = !d.window
window,/free,/pixmap,xsize = xsize,ysize = ysize
winPix2 = !d.window

; Create some stuff to plot
nx = 100
xlo = -10.0 & xhi = 10.0 & dx = (xhi-xlo)/(nx-1.)
x1 = xlo+dx*findgen(nx)
y1 = cos(0.5*x1)
data1 = [[x1],[y1]]
xlo = -1.0 & xhi = 1.0 & dx = (xhi-xlo)/(nx-1.)
x2 = xlo+dx*findgen(nx)
y2 = sin(2.0*x2)
data1 = [[x1],[y1]]
data2 = [[x2],[y2]]
dataPtr1 = ptr_new(data1,/no_copy)
dataPtr2 = ptr_new(data2,/no_copy)

win1State = {	win:win1,		$
				winPix:winPix1,	$
				winVis:winVis1, $
				autoscale:1,	$
				mouse:0B,		$
				xPtr:ptr_new(/allocate_heap),	$
				yPtr:ptr_new(/allocate_heap),	$
				xrange:fltarr(2),	$
				yrange:fltarr(2),	$
				xpos:0.0,	$
				ypos:0.0	$
			}
win2State = {	win:win2,		$
				winPix:winPix2,	$
				winVis:winVis2,	$
				autoscale:1,	$
				mouse:0B,		$
				xPtr:ptr_new(/allocate_heap),	$
				yPtr:ptr_new(/allocate_heap),	$
				xrange:fltarr(2),	$
				yrange:fltarr(2),	$
				xpos:0.0,	$
				ypos:0.0	$
			}

state = {	win1State:win1State,	$
			win2State:win2State,	$
			dataPtr1:dataPtr1,		$
			dataPtr2:dataPtr2		$
		}
pState = ptr_new(state,/no_copy)
widget_control,tlb,set_uvalue = pState

pEvent = {event,id:(*pState).win1State.win,top:tlb,handler:0L}
refresh1,pEvent
refresh2,pEvent

xmanager,'xtw',tlb,event_handler = 'xtwEvent',cleanup = 'xtwCleanup'
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;